SystemOrganization addCategory: #'OpenCourses-Tests'!
SystemOrganization addCategory: #OpenCourses!

Object subclass: #Data
	instanceVariableNames: ''
	classVariableNames: 'MaterialList UserList'
	poolDictionaries: ''
	category: 'OpenCourses'!

!Data class methodsFor: 'as yet unclassified' stamp: 'jsa 5/11/2013 18:24'!
blankData
	UserList := Set new.
	MaterialList := Set new.! !

!Data class methodsFor: 'as yet unclassified' stamp: 'jsa 5/11/2013 18:19'!
materialList
	^ MaterialList! !

!Data class methodsFor: 'as yet unclassified' stamp: 'jsa 5/11/2013 18:19'!
materialList: aMaterialList
	MaterialList := aMaterialList! !

!Data class methodsFor: 'as yet unclassified' stamp: 'jsa 5/11/2013 18:19'!
userList
	^ UserList! !

!Data class methodsFor: 'as yet unclassified' stamp: 'jsa 5/11/2013 18:19'!
userList: aUserList
	UserList := aUserList! !

Object subclass: #DidacticMaterial
	instanceVariableNames: 'file title description authors owner licence creationDate lastUploadDate type tags'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OpenCourses'!

!DidacticMaterial methodsFor: 'accessing' stamp: 'jsa 5/11/2013 17:12'!
authors
	"Answer the value of authors"

	^ authors! !

!DidacticMaterial methodsFor: 'accessing' stamp: 'jsa 5/11/2013 17:12'!
authors: anObject
	"Set the value of authors"

	authors := anObject! !

!DidacticMaterial methodsFor: 'accessing' stamp: 'jsa 5/11/2013 17:12'!
creationDate
	"Answer the value of creationDate"

	^ creationDate! !

!DidacticMaterial methodsFor: 'accessing' stamp: 'jsa 5/11/2013 17:12'!
creationDate: anObject
	"Set the value of creationDate"

	creationDate := anObject! !

!DidacticMaterial methodsFor: 'accessing' stamp: 'jsa 5/11/2013 17:13'!
description
	"Answer the value of description"

	^ description! !

!DidacticMaterial methodsFor: 'accessing' stamp: 'jsa 5/11/2013 17:13'!
description: anObject
	"Set the value of description"

	description := anObject! !

!DidacticMaterial methodsFor: 'accessing' stamp: 'jsa 5/11/2013 17:12'!
file
	"Answer the value of file"

	^ file! !

!DidacticMaterial methodsFor: 'accessing' stamp: 'jsa 5/11/2013 17:12'!
file: anObject
	"Set the value of file"

	file := anObject! !

!DidacticMaterial methodsFor: 'accessing' stamp: 'jsa 5/11/2013 17:12'!
lastUploadDate
	"Answer the value of lastUploadDate"

	^ lastUploadDate! !

!DidacticMaterial methodsFor: 'accessing' stamp: 'jsa 5/11/2013 17:12'!
lastUploadDate: anObject
	"Set the value of lastUploadDate"

	lastUploadDate := anObject! !

!DidacticMaterial methodsFor: 'accessing' stamp: 'jsa 5/11/2013 17:12'!
licence
	"Answer the value of licence"

	^ licence! !

!DidacticMaterial methodsFor: 'accessing' stamp: 'jsa 5/11/2013 17:12'!
licence: anObject
	"Set the value of licence"

	licence := anObject! !

!DidacticMaterial methodsFor: 'accessing' stamp: 'jsa 5/11/2013 17:12'!
owner
	"Answer the value of owner"

	^ owner! !

!DidacticMaterial methodsFor: 'accessing' stamp: 'jsa 5/11/2013 17:12'!
owner: anObject
	"Set the value of owner"

	owner := anObject! !

!DidacticMaterial methodsFor: 'accessing' stamp: 'jsa 5/11/2013 17:12'!
tags
	"Answer the value of tags"

	^ tags! !

!DidacticMaterial methodsFor: 'accessing' stamp: 'jsa 5/11/2013 17:12'!
tags: anObject
	"Set the value of tags"

	tags := anObject! !

!DidacticMaterial methodsFor: 'accessing' stamp: 'jsa 5/11/2013 17:12'!
title
	"Answer the value of title"

	^ title! !

!DidacticMaterial methodsFor: 'accessing' stamp: 'jsa 5/11/2013 17:12'!
title: anObject
	"Set the value of title"

	title := anObject! !

!DidacticMaterial methodsFor: 'accessing' stamp: 'jsa 5/11/2013 17:12'!
type
	"Answer the value of type"

	^ type! !

!DidacticMaterial methodsFor: 'accessing' stamp: 'jsa 5/11/2013 17:12'!
type: anObject
	"Set the value of type"

	type := anObject! !

Object subclass: #DidacticMaterialSearchSpecs
	instanceVariableNames: 'title description authors owner licence creationDateStart creationDateEnd lastUploadDateStart lastUploadDateEnd type tags'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OpenCourses'!

!DidacticMaterialSearchSpecs methodsFor: 'accessing' stamp: 'jsa 5/11/2013 19:34'!
authors
	"Answer the value of authors"

	^ authors! !

!DidacticMaterialSearchSpecs methodsFor: 'accessing' stamp: 'jsa 5/11/2013 19:34'!
authors: anObject
	"Set the value of authors"

	authors := anObject! !

!DidacticMaterialSearchSpecs methodsFor: 'accessing' stamp: 'jsa 5/11/2013 19:34'!
creationDateEnd
	"Answer the value of creationDateEnd"

	^ creationDateEnd! !

!DidacticMaterialSearchSpecs methodsFor: 'accessing' stamp: 'jsa 5/11/2013 19:34'!
creationDateEnd: anObject
	"Set the value of creationDateEnd"

	creationDateEnd := anObject! !

!DidacticMaterialSearchSpecs methodsFor: 'accessing' stamp: 'jsa 5/11/2013 19:34'!
creationDateStart
	"Answer the value of creationDateStart"

	^ creationDateStart! !

!DidacticMaterialSearchSpecs methodsFor: 'accessing' stamp: 'jsa 5/11/2013 19:34'!
creationDateStart: anObject
	"Set the value of creationDateStart"

	creationDateStart := anObject! !

!DidacticMaterialSearchSpecs methodsFor: 'accessing' stamp: 'jsa 5/11/2013 19:34'!
description
	"Answer the value of description"

	^ description! !

!DidacticMaterialSearchSpecs methodsFor: 'accessing' stamp: 'jsa 5/11/2013 19:34'!
description: anObject
	"Set the value of description"

	description := anObject! !

!DidacticMaterialSearchSpecs methodsFor: 'accessing' stamp: 'jsa 5/11/2013 19:34'!
lastUploadDateEnd
	"Answer the value of lastUploadDateEnd"

	^ lastUploadDateEnd! !

!DidacticMaterialSearchSpecs methodsFor: 'accessing' stamp: 'jsa 5/11/2013 19:34'!
lastUploadDateEnd: anObject
	"Set the value of lastUploadDateEnd"

	lastUploadDateEnd := anObject! !

!DidacticMaterialSearchSpecs methodsFor: 'accessing' stamp: 'jsa 5/11/2013 19:34'!
lastUploadDateStart
	"Answer the value of lastUploadDateStart"

	^ lastUploadDateStart! !

!DidacticMaterialSearchSpecs methodsFor: 'accessing' stamp: 'jsa 5/11/2013 19:34'!
lastUploadDateStart: anObject
	"Set the value of lastUploadDateStart"

	lastUploadDateStart := anObject! !

!DidacticMaterialSearchSpecs methodsFor: 'accessing' stamp: 'jsa 5/11/2013 19:34'!
licence
	"Answer the value of licence"

	^ licence! !

!DidacticMaterialSearchSpecs methodsFor: 'accessing' stamp: 'jsa 5/11/2013 19:34'!
licence: anObject
	"Set the value of licence"

	licence := anObject! !

!DidacticMaterialSearchSpecs methodsFor: 'as yet unclassified' stamp: 'jsa 5/11/2013 19:52'!
matches: aDidacticMaterial
	self title ifNotNil: [aDidacticMaterial title = self title ifFalse: [^ false]].
	self creationDateStart ifNotNil: [aDidacticMaterial creationDate > self creationDateStart ifFalse: [^ false]].
	self creationDateEnd ifNotNil: [aDidacticMaterial creationDate < self creationDateEnd ifFalse: [^ false]].
	^ true.! !

!DidacticMaterialSearchSpecs methodsFor: 'accessing' stamp: 'jsa 5/11/2013 19:34'!
owner
	"Answer the value of owner"

	^ owner! !

!DidacticMaterialSearchSpecs methodsFor: 'accessing' stamp: 'jsa 5/11/2013 19:34'!
owner: anObject
	"Set the value of owner"

	owner := anObject! !

!DidacticMaterialSearchSpecs methodsFor: 'accessing' stamp: 'jsa 5/11/2013 19:34'!
tags
	"Answer the value of tags"

	^ tags! !

!DidacticMaterialSearchSpecs methodsFor: 'accessing' stamp: 'jsa 5/11/2013 19:34'!
tags: anObject
	"Set the value of tags"

	tags := anObject! !

!DidacticMaterialSearchSpecs methodsFor: 'accessing' stamp: 'jsa 5/11/2013 19:34'!
title
	"Answer the value of title"

	^ title! !

!DidacticMaterialSearchSpecs methodsFor: 'accessing' stamp: 'jsa 5/11/2013 19:34'!
title: anObject
	"Set the value of title"

	title := anObject! !

!DidacticMaterialSearchSpecs methodsFor: 'accessing' stamp: 'jsa 5/11/2013 19:34'!
type
	"Answer the value of type"

	^ type! !

!DidacticMaterialSearchSpecs methodsFor: 'accessing' stamp: 'jsa 5/11/2013 19:34'!
type: anObject
	"Set the value of type"

	type := anObject! !

Object subclass: #FakeFile
	instanceVariableNames: 'title contents'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OpenCourses'!

!FakeFile methodsFor: 'accessing' stamp: 'jsa 5/11/2013 16:50'!
contents
	"Answer the value of contents"

	^ contents! !

!FakeFile methodsFor: 'accessing' stamp: 'jsa 5/11/2013 16:50'!
contents: anObject
	"Set the value of contents"

	contents := anObject! !

!FakeFile methodsFor: 'accessing' stamp: 'jsa 5/11/2013 16:50'!
title
	"Answer the value of title"

	^ title! !

!FakeFile methodsFor: 'accessing' stamp: 'jsa 5/11/2013 16:50'!
title: anObject
	"Set the value of title"

	title := anObject! !

Object subclass: #MaterialManager
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OpenCourses'!

!MaterialManager methodsFor: 'private' stamp: 'jsa 5/11/2013 18:21'!
materialList
	^ Data materialList! !

!MaterialManager methodsFor: 'as yet unclassified' stamp: 'jsa 5/11/2013 19:35'!
search: aDidacticMaterialSearchSpecs
	^ Data materialList select: [ :material | aDidacticMaterialSearchSpecs matches: material]! !

!MaterialManager methodsFor: 'as yet unclassified' stamp: 'jsa 5/11/2013 18:40'!
submitMaterial: submittedFile title: title authors: authorsList description: description type: type licence: licence tags: tags
	| material now user|
	now := TimeStamp now.
	user := Session user.
	UserManager new canSubmitMaterial ifTrue: [
	material := DidacticMaterial new file: submittedFile; title: title; authors: authorsList; description: description; type: type; licence: licence; tags: tags; creationDate: now; lastUploadDate: now; owner: user.
	Data materialList add: material]
	ifFalse: [Error signal: 'User doesn''t have permission to submit material']! !

Object subclass: #Session
	instanceVariableNames: ''
	classVariableNames: 'CurrentUser'
	poolDictionaries: ''
	category: 'OpenCourses'!

!Session class methodsFor: 'as yet unclassified' stamp: 'cmb 5/10/2013 18:58'!
user
	^CurrentUser! !

!Session class methodsFor: 'as yet unclassified' stamp: 'cmb 5/10/2013 18:58'!
user: aUser
	CurrentUser := aUser! !

Object subclass: #User
	instanceVariableNames: 'name password email'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OpenCourses'!

!User methodsFor: 'as yet unclassified' stamp: 'jsa 5/11/2013 18:42'!
= aUser 
	^ self email = aUser email! !

!User methodsFor: 'accessing' stamp: 'cmb 5/10/2013 16:30'!
email
	"Answer the value of email"

	^ email! !

!User methodsFor: 'accessing' stamp: 'cmb 5/10/2013 16:30'!
email: anObject
	"Set the value of email"

	email := anObject! !

!User methodsFor: 'as yet unclassified' stamp: 'cmb 5/10/2013 17:33'!
hash
	^ email hash! !

!User methodsFor: 'accessing' stamp: 'cmb 5/10/2013 16:34'!
name
	"Answer the value of name"
	^ name! !

!User methodsFor: 'accessing' stamp: 'cmb 5/10/2013 16:31'!
name: anObject
	"Set the value of name"

	name := anObject! !

!User methodsFor: 'accessing' stamp: 'cmb 5/10/2013 16:30'!
password
	"Answer the value of password"

	^ password! !

!User methodsFor: 'accessing' stamp: 'cmb 5/10/2013 16:30'!
password: anObject
	"Set the value of password"

	password := anObject! !

Object subclass: #UserManager
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OpenCourses'!

!UserManager methodsFor: 'as yet unclassified' stamp: 'jsa 5/11/2013 18:44'!
canSubmitMaterial
	^ (Session user isNil) not! !

!UserManager methodsFor: 'as yet unclassified' stamp: 'jsa 5/11/2013 18:21'!
hasUser: aUser 
	^ Data userList includes: aUser! !

!UserManager methodsFor: 'as yet unclassified' stamp: 'jsa 5/11/2013 18:22'!
login: email password: password 
	| user registeredUser |
	user := User new email: email;
				 password: password.
	registeredUser := Data userList
				like: user
				ifAbsent: [Error signal: 'User/Password incorrect!!'].
	user password = registeredUser password
		ifTrue: [Session user: registeredUser]
		ifFalse: [Error signal: 'User/Password incorrect!!']! !

!UserManager methodsFor: 'as yet unclassified' stamp: 'jsa 5/11/2013 18:22'!
registerNewUser: name password: password email: email 
	| newUser |
	newUser := User new name: name;
				 password: password;
				 email: email.
	(Data userList includes: newUser)
		ifFalse: [Data userList add: newUser]
		ifTrue: [Error signal: 'Duplicated user']! !

!UserManager methodsFor: 'accessing' stamp: 'cmb 5/10/2013 17:28'!
userList
	"Answer the value of userList"

	^ userList! !

!UserManager methodsFor: 'accessing' stamp: 'cmb 5/10/2013 17:28'!
userList: anObject
	"Set the value of userList"

	userList := anObject! !

TestCase subclass: #MaterialManagerTest
	instanceVariableNames: 'emptyMaterialList nonEmptyMaterialList materialManager authorsList submittedFile tags'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OpenCourses-Tests'!

!MaterialManagerTest methodsFor: 'as yet unclassified' stamp: 'jsa 5/11/2013 18:36'!
setUp
 	Data blankData.
	authorsList := OrderedCollection new add: 'author1'; add: 'author2'.
	submittedFile := FakeFile new title: 'file title'; contents: (ByteArray new).
	tags := SortedCollection new add: 'OOP'; add: 'Smalltalk'.
	emptyMaterialList := Data materialList copy.
	materialManager := MaterialManager new.
	materialManager submitMaterial: submittedFile title: 'title' authors: authorsList description: 'description' type: 'slide show' licence: 'GPLv3' tags: tags.
	nonEmptyMaterialList := Data materialList copy.! !

!MaterialManagerTest methodsFor: 'as yet unclassified' stamp: 'jsa 5/11/2013 19:34'!
testSearchByTitle
	| searchSpecsNoResult searchSpecsWithResult |
	Data materialList: nonEmptyMaterialList.
	searchSpecsNoResult := DidacticMaterialSearchSpecs new title: 'wrong title'.
	self assert: (materialManager search: searchSpecsNoResult) size == 0.
	searchSpecsWithResult := DidacticMaterialSearchSpecs new title: 'title'.
	self assert: (materialManager search: searchSpecsWithResult) size == 1.! !

!MaterialManagerTest methodsFor: 'as yet unclassified' stamp: 'jsa 5/11/2013 19:43'!
testSearchByTitleAndCreationDate
	| searchSpecsNoResult searchSpecsWithResult |
	Data materialList: nonEmptyMaterialList.
	searchSpecsNoResult := DidacticMaterialSearchSpecs new title: 'title'; creationDateStart: (TimeStamp now plusSeconds: 4); creationDateEnd: (TimeStamp now plusSeconds: 10).
	self assert: (materialManager search: searchSpecsNoResult) size == 0.
	searchSpecsWithResult := DidacticMaterialSearchSpecs new title: 'title'; creationDateStart: (TimeStamp now minusSeconds: 14); creationDateEnd: (TimeStamp now plusSeconds: 10).
	self assert: (materialManager search: searchSpecsWithResult) size == 1.! !

!MaterialManagerTest methodsFor: 'as yet unclassified' stamp: 'jsa 5/11/2013 18:35'!
testSubmitMaterial
	Data materialList: emptyMaterialList.
	materialManager submitMaterial: submittedFile title: 'title' authors: authorsList description: 'description' type: 'slide show' licence: 'GPLv3' tags: tags.
	self assert: (materialManager materialList select: [:material | material title = 'title']) size == 1.! !

!MaterialManagerTest methodsFor: 'as yet unclassified' stamp: 'jsa 5/11/2013 18:36'!
testSubmitMaterialAutomaticFields
	| loggedUser now maxDuration|
	Data materialList: emptyMaterialList.
	loggedUser := User new email: 'user@email.com'.
	Session user: loggedUser.
	maxDuration := Duration seconds: 1.
	now := TimeStamp now.
	materialManager submitMaterial: submittedFile title: 'title' authors: authorsList description: 'description' type: 'slide show' licence: 'GPLv3' tags: tags.
	self assert: (materialManager materialList select: [:material | material owner = loggedUser and: material creationDate - now <  maxDuration and: material lastUploadDate - now < maxDuration]) size == 1.! !

!MaterialManagerTest methodsFor: 'as yet unclassified' stamp: 'jsa 5/11/2013 18:37'!
testSubmitMaterialWithoutLogin
	Data materialList: emptyMaterialList.
	Session user: nil.
	self should: [materialManager submitMaterial: submittedFile title: 'title' authors: authorsList description: 'description' type: 'slide show' licence: 'GPLv3' tags: tags] raise: Error.
	self assert: (materialManager materialList select: [:material | material title = 'title']) size == 0.! !

TestCase subclass: #UserManagerTest
	instanceVariableNames: 'emptyUserList nonEmptyUserList userManager'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OpenCourses-Tests'!

!UserManagerTest methodsFor: 'as yet unclassified' stamp: 'jsa 5/11/2013 18:37'!
setUp
	Data blankData.
	emptyUserList := Data userList copy.
	userManager := UserManager new.
	userManager registerNewUser: 'john' password: '123admin' email: 'johnadmin@me.com'.
	nonEmptyUserList := Data userList copy.
! !

!UserManagerTest methodsFor: 'as yet unclassified' stamp: 'jsa 5/11/2013 18:30'!
testLogin
	| loggedUser |
	Data userList: nonEmptyUserList.
	self
		should: [userManager login: 'emailDoesntExist' password: '123admin']
		raise: Error.
	self
		should: [userManager login: 'johnadmin@me.com' password: 'wrongPassword']
		raise: Error.
	loggedUser := User new email: 'johnadmin@me.com'.
	self
		should: [userManager login: 'johnadmin@me.com' password: '123admin'.
			Session user = loggedUser]! !

!UserManagerTest methodsFor: 'as yet unclassified' stamp: 'jsa 5/11/2013 18:31'!
testRegisterNewUser
	| createdUser |
	createdUser := User new name: 'john';
				 password: '123admin';
				 email: 'johnadmin@me.com'.
	Data userList: emptyUserList.
	self
		shouldnt: [userManager hasUser: createdUser].
	userManager
		registerNewUser: 'john'
		password: '123admin'
		email: 'johnadmin@me.com'.
	self
		assert: (userManager hasUser: createdUser)! !

!UserManagerTest methodsFor: 'as yet unclassified' stamp: 'jsa 5/11/2013 18:31'!
testTryToRegisterAnAlreadyRegisteredUser
	Data userList: nonEmptyUserList.
	self
		should: [userManager
				registerNewUser: 'jon'
				password: '123admin321'
				email: 'johnadmin@me.com']
		raise: Error! !
